
v   : atom.
exp : data.
tp  : data.

int   : tp.
arrow : tp * tp -> tp.


var    : @v -> exp.
let    : exp * <v> exp -> exp.
app    : exp * exp -> exp.
fn     : <v> exp -> exp.
letfun : <v> (<v>exp * exp) -> exp.
plus   : exp * exp -> exp.
z      : exp.
s      : exp -> exp.
case   : exp * exp * <v> exp -> exp.






subst :  <v>exp * exp * exp -> prop.
subst (<a>var @a, E, E).
subst (<a>var B, E, var B) <- a # B.
subst (<a>app(E1,E2), E, app(E3,E4)) <- subst (<a>E1,E,E3), subst (<a>E2,E,E4).
subst (<a>fn <b> E1, E, fn <b> E2) / b # E <- subst (<a>E1, E, E2).
subst (<a>plus(E1,E2), E, plus(F1,F2)) <- subst (<a>E1,E,F1), subst (<a>E2, E, F2).
subst (<a>s(E1), E, s(F1)) <- subst (<a>E1,E,F1).
subst (<a>z, E, z).
subst (<a>case(E1,E2,<b>E3), E, case(F1,F2,<b>F3)) / b # E3 <-
	subst(<a>E1,E,F1), subst(<a>E2,E,F2), subst(<a>E3,E,F3).
subst (<a>letfun <f>(<b>E1,E2),E,letfun <f>(<b>F1,F2)) / f # (E1,E2), b # E2 <-
	subst(<a>E1,E,F1), subst(<a>E2,E,F2).
  	
ctxlookup : (@v * <v>exp) list * @v * <v>exp -> prop.
ctxlookup ([(A,F)|S],A,F).
ctxlookup ([(B,_)|S],A,F) <- ctxlookup(S,A,F).

byname :  (@v * <v>exp) list * exp * exp -> prop.
byname(S,app (E1, E2), V) <- 
	byname (S,E1,fn <a> E), subst (<a>E,E2,E3), byname (S, E3, V).
byname(S,fn<a> E, fn<a> E).
byname(S,z,z).
byname(S,s(E), s(V)) <- byname(S,E,V).
byname(S,plus(E1,E2), V) <- byname(S,E1,z), byname(S,E2,V).
byname(S,plus(E1,E2), s(V)) <- byname(S,E1,s(V1)), byname(S,plus(V1,E2),V).
byname(S,let (E1,<x> E2),V) <- subst (<x>E2,E1,E3), byname(S,E3,V).
byname(S,case(E1,E2,<x>E3),V) <- byname(S,E1,z), byname(S,E2,V).
byname(S,case(E1,E2,<x>E3),V) <- 
	byname(S,E1,s(V1)), subst(<x>E3,V1,E4), byname(S,E4,V).
byname(S,letfun <f>(<x>E1, E2), V) / f # S <-
	byname([(@f,<x>E1)|S],E2,V).
byname(S,var A, V) <- ctxlookup(S,A,F), byname(S, fn F, V).


byval :  (@v * <v>exp) list * exp * exp -> prop.
byval(S,app (E1, E2), V) <- 
	byval (S,E1,fn <a> E), byval (S,E2, V2), subst (<a>E,V2,E3), byval (S,E3, V).
byval(S,fn<a> E, fn<a> E).
byval(S,z,z).
byval(S,s(E), s(V)) <- byval(S,E,V).
byval(S,plus(E1,E2), V) <- byval(S,E1,z), byval(S,E2,V).
byval(S,plus(E1,E2), s(V)) <- byval(S,E1,s(V1)), byval(S,plus(V1,E2),V).
byval(S,let (E1,<x> E2), V) <- byval (S,E1,V1), subst (<x>E2,V1,E3), byval(S,E3,V).
byval(S,case(E1,E2,<x>E3),V) <- byval(S,E1,z), byval(S,E2,V).
byval(S,case(E1,E2,<x>E3),V) <- 
	byval(S,E1,s(V1)), subst(<x>E3,V1,E4), byval(S,E4,V).
byval(S,letfun <f>(<x>E1, E2), V) / f # S <-
	byval([(@f,<x>E1)|S],E2,V).
byval(S,var A, V) <- ctxlookup(S,A,F), byval(S, fn F, V).


tclookup : (@v * tp) list * @v * tp -> prop.

tclookup([(A, T)|G], A, T).
tclookup([(B, _)|G], Y, T) <-  tclookup(G,Y,T).

tc : (@v * tp) list * exp * tp -> prop.

tc(G, var X,T) <- tclookup (G,X,T).
tc(G, z, int).
tc(G, s(E), int) <- tc(G,E,int).
tc(G, plus(E1,E2), int) <- tc(G, E1, int) , tc (G,E2,int).
tc(G, fn <a>  E, arrow (T1,T2)) / a # G <- tc([(@a,T1)|G], E, T2).
tc(G, let (E1, <a>E2), T) / a # G <- tc(G,E1,T1), tc([(@a,T1)|G], E2, T2).
tc(G, letfun <f>(<a> E1, E2), T) / f # G, a # G <- 
	tc([(@a,T1),(@f,arrow(T1,T2))|G],E1,T2), 
	tc([(@f,arrow(T1,T2))|G], E2, T).
tc(G, app(E1,E2), T) <- 
	tc(G,E1,arrow(T0,T)), tc(G,E2,T0).
tc(G, case(E1,E2,<a>E3), T) / a # G <-
	tc(G,E1,int),
        tc(G,E2,T),
	tc([(@a,int)|G],E3,T).


value : exp -> prop.
value(z).
value(s V) <- value V.
value(fn <a> E).
