#load "absyn.cmo";;
#load "unify.cmo";;
#load "lexer.cmo";;
#load "parser.cmo";;
open Absyn;;
open Unify;;

let fn (a, e) = App ("fn", Abs(a,e))
let vr a = Atom(a)
let app (e1,e2) = App("app", Pair(e1,e2))
let lv (a,e1,e2) = App("let", Pair(e1, Abs(a,e2)))
let lf (f,a,e1,e2) = App("let fun", Abs(f,Pair(Abs(a,e1),e2)))

let mvar x = Susp([],x)



let parse s = Parser.parse (Lexer.lex) (Lexing.from_string s)
let parse_tm s = Parser.parse_tm (Lexer.lex) (Lexing.from_string s)
let parse_tp s = Parser.parse_tp (Lexer.lex) (Lexing.from_string s)
let lex s = (Lexer.lex) (Lexing.from_string s)
let lex' s = 
  let b = Lexing.from_string s in
  let rec go () = 
    let t = Lexer.lex b in
    if t = Parser.EOF then [] else t::(go ())
  in go ()


let t1 = parse_tm "fn <@a> fn <@b> app (X1,vr @b)";;
let u1 = parse_tm "fn <@a> fn <@b> app (vr @a, X1)";;

let t2 = parse_tm "fn<@a> fn<@b> app(X2,vr @b)";;
let u2 = parse_tm "fn<@b> fn<@a> app(vr @a,X3)";;

let t3 = parse_tm "fn <@a> fn <@b> app(vr @b, X4)";;
let u3 = parse_tm "fn <@b> fn <@a> app(vr @a, X5)";;

let t4 = parse_tm " fn <@a> fn <@b> app(vr @b, X6)";;
let u4 = parse_tm "fn <@a> fn <@a> app (vr @a, X7)";;
