var : atom.
exp : type.
tp : type.

int : tp.
arrow : tp * tp -> tp.


var    : @var -> exp.
app    : exp * exp -> exp.
fn     : <var> exp -> exp.
let    : exp * <var> exp -> exp.
letfun : <var> ( <var>exp * exp ) -> exp.
plus   : exp * exp -> exp.
zero   : exp.
succ   : exp -> exp.
case   : exp * exp * <var> exp -> exp.

subst :  <var>(exp * exp *exp) -> prop.
subst <a>(var B, E, var B).
subst <a>(var @a, E, E).
subst <a>(app(E1,E2), E, app(E3,E4)) <- subst <a>(E1,E,E3), subst <a>(E2,E,E4).
subst <a>(fn <b> E1, E, fn <b> E2) <- subst <a>(E1, E, E2).
subst <a>(plus(E1,E2), E, plus(F1,F2)) <- subst <a>(E1,E,F1), subst <a>(E2, E, F2).
subst <a>(s(E1), E, s(F1)) <- subst <a>(E1,E,F1).
subst <a>(zero, E, zero).

subst2 :  <var>(exp * exp *exp) -> prop.
subst2 (var A, A, E, E).
subst2 (var B, A, E, var @b).
subst2 (app(E1,E2), A, E, app(E3,E4)) <- subst2 (E1, A, E,E3), subst2 (E2, A,E,E4).
subst2 (fn <b> E1, A, E, fn <b> E2) <- subst2 (E1, A, E, E2).

subst <a>(var @b, zero, E) ?-.
subst2 (var @b, @a, zero, E) ?-.
subst <a>(var @a, zero, E) ?-.
subst2 (var @a, @a, zero, E) ?-.

subst <x>((fn <y> var @x), var @y, E) ?-.
subst2 ((fn <y> var @x), @x, var @y, E) ?-.

subst <x>((fn <y> var @x), zero, E) ?-.
subst2 ((fn <y> var @x), @x, zero, E) ?-.

subst <x>((fn <y> var @x), X, E) ?-.
subst2 ((fn <y> var @x), @x, X, E) ?-.

